
uniform int whichOne;
varying vec2 TexCoord;

#define KERNEL_SIZE 9

// Gaussian kernel
// 1 2 1
// 2 4 2
// 1 2 1	
float kernel[KERNEL_SIZE];

uniform sampler2D colorMap;
float width  = 512.0;
float height = 512.0;

float step_w = 1.0/width;
float step_h = 1.0/height;

vec2 offset[KERNEL_SIZE];
						 
void main(void)
{
   vec4 sum = vec4(0.0);
   
   offset[0] = vec2(-step_w, -step_h);
   offset[1] = vec2(0.0, -step_h);
   offset[2] = vec2(step_w, -step_h);
   
   offset[3] = vec2(-step_w, 0.0);
   offset[4] = vec2(0.0, 0.0);
   offset[5] = vec2(step_w, 0.0);
   
   offset[6] = vec2(-step_w, step_h);
   offset[7] = vec2(0.0, step_h);
   offset[8] = vec2(step_w, step_h);

   //do nothing
    if (whichOne == 0)
        {
        kernel[0] =  0.0;  kernel[1] =  0.0;	kernel[2] =  0.0;
        kernel[3] =  0.0;  kernel[4] =  1.0;	kernel[5] =  0.0;
        kernel[6] =  0.0;  kernel[7] =  0.0;	kernel[8] =  0.0;
        }


   //gaussian filter to blur the image
    if (whichOne == 1)
        {
        kernel[0] =  0.06;  kernel[1] =  0.13;	kernel[2] =  0.06;
        kernel[3] =  0.13;  kernel[4] =  0.25;	kernel[5] =  0.13;
        kernel[6] =  0.06;  kernel[7] =  0.13;	kernel[8] =  0.06;
        }
 
   //mean filter for noise reduction 
    if (whichOne == 2)
        {
        kernel[0] =  0.11;  kernel[1] =  0.11;	kernel[2] =  0.11;
        kernel[3] =  0.11;  kernel[4] =  0.11;	kernel[5] =  0.11;
        kernel[6] =  0.11;  kernel[7] =  0.11;	kernel[8] =  0.11;
        }

   //Laplace for Edge Detection 
    if (whichOne == 3)
        {
        kernel[0] =  0.0;  kernel[1] =  1.0;	kernel[2] =  0.0;
        kernel[3] =  1.0;  kernel[4] = -4.0;	kernel[5] =  1.0;
        kernel[6] =  0.0;  kernel[7] =  1.0;	kernel[8] =  0.0;
        }
  
   //embossing
    if (whichOne == 4)
        {
        kernel[0] =  2.0;  kernel[1] =  0.0;	kernel[2] =  0.0;
        kernel[3] =  0.0;  kernel[4] = -1.0;	kernel[5] =  0.0;
        kernel[6] =  0.0;  kernel[7] =  0.0;	kernel[8] = -1.0;
        }

   //sharpening 
    if (whichOne == 5)
        {
        kernel[0] = -1.0;  kernel[1] = -1.0;	kernel[2] = -1.0;
        kernel[3] = -1.0;  kernel[4] =  9.0;	kernel[5] = -1.0;
        kernel[6] = -1.0;  kernel[7] = -1.0;	kernel[8] = -1.0;
        }
   
   
   if(TexCoord.s<0.495)
   {   
	vec4 tmp = texture2D(colorMap, TexCoord.st + offset[0]);
	sum += tmp * kernel[0];
	tmp = texture2D(colorMap, TexCoord.st + offset[1]);
	sum += tmp * kernel[1];
	tmp = texture2D(colorMap, TexCoord.st + offset[2]);
	sum += tmp * kernel[2];
	tmp = texture2D(colorMap, TexCoord.st + offset[3]);
	sum += tmp * kernel[3];
	tmp = texture2D(colorMap, TexCoord.st + offset[4]);
	sum += tmp * kernel[4];
	tmp = texture2D(colorMap, TexCoord.st + offset[5]);
	sum += tmp * kernel[5];
	tmp = texture2D(colorMap, TexCoord.st + offset[6]);
	sum += tmp * kernel[6];
	tmp = texture2D(colorMap, TexCoord.st + offset[7]);
	sum += tmp * kernel[7];
	tmp = texture2D(colorMap, TexCoord.st + offset[8]);
	sum += tmp * kernel[8];
   }
   else if( TexCoord.s>0.50505 )
   {
		sum = texture2D(colorMap, TexCoord.xy);
   }
   else
   {
		sum = vec4(1.0, 0.0, 0.0, 1.0);
	}

   gl_FragColor = sum;
}